﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.01
@EndOfDesignText@
'Custom View class - ProgressBarIndicator

'#Event: ExampleEvent (Value As Int)

#DesignerProperty: Key: ProgressBarColor, DisplayName: Progressbar Color, FieldType: Color, DefaultValue: #FFFFFF00, Description: You can use the built-in color picker to find the color values.
#DesignerProperty: Key: LabelTextColor, DisplayName: Label Text Color, FieldType: Color, DefaultValue: #FFFF0000, Description: You can use the built-in color picker to find the color values.

'#DesignerProperty: Key: BooleanExample, DisplayName: Boolean Example, FieldType: Boolean, DefaultValue: True, Description: Example of a boolean property.
'#DesignerProperty: Key: IntExample, DisplayName: Int Example, FieldType: Int, DefaultValue: 10, MinRange: 0, MaxRange: 100, Description: Note that MinRange and MaxRange are optional.
'#DesignerProperty: Key: StringWithListExample, DisplayName: String With List, FieldType: String, DefaultValue: Sunday, List: Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday
'#DesignerProperty: Key: StringExample, DisplayName: String Example, FieldType: String, DefaultValue: Text
'#DesignerProperty: Key: ColorExample, DisplayName: Color Example, FieldType: Color, DefaultValue: 0xFFCFDCDC, Description: You can use the built-in color picker to find the color values.
'#DesignerProperty: Key: DefaultColorExample, DisplayName: Default Color Example, FieldType: Color, DefaultValue: Null, Description: Setting the default value to Null means that a nullable field will be displayed.

Sub Class_Globals
	Private fx As JFX
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Pane
	Private mProps As Map
	Private mProgressBarColor As Paint
	' ProgressBar with Label
	Private ProgressBar_Indicator As ProgressBar	'ignore
	Private Label_Indicator As Label				'ignore
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	' Assign the Base and the Properties to the local class vars
	mBase = Base
	mProps = Props
	' Init and add the views to the base pane
	ProgressBar_Indicator.Initialize("PBI")
	Base.AddNode(ProgressBar_Indicator, 0,0,0,0)
	Label_Indicator.Initialize("LI")
	Base.AddNode(Label_Indicator, 0,0,0,0)
	' Load the layout
	CallSubDelayed2(Me, "AfterLoadLayout", Props)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	ProgressBar_Indicator.SetLayoutAnimated(0, 0, 0, Width - Height, Height)
	Label_Indicator.SetLayoutAnimated(0, Max(0, Width - Height), 0, Height, Height)
End Sub

Public Sub GetBase As Pane
	Return mBase
End Sub

' Load the layout and set styling including assigning the properties
Private Sub AfterLoadLayout(Props As Map)
	mBase.LoadLayout("ProgressBarIndicator")
	' ProgressBarIndicator
	CSSUtils.SetStyleProperty(ProgressBar_Indicator, "-fx-accent", CSSUtils.ColorToHex(mProps.Get("ProgressBarColor")))
	mProgressBarColor = mProps.Get("ProgressBarColor")
	' LabelIndicator
	CSSUtils.SetStyleProperty(Label_Indicator, "-fx-text-fill", CSSUtils.ColorToHex(mProps.Get("LabelTextColor")))
	CSSUtils.SetBackgroundColor(Label_Indicator, fx.Colors.Transparent)
End Sub

' Set or get the progressbar progress value
Public Sub setProgress(Progress As Double)
	ProgressBar_Indicator.Progress = Progress
	Label_Indicator.Text = $"${NumberFormat(Progress * 100, 0, 0)}%"$
End Sub
Public Sub getProgress As Double
	Return ProgressBar_Indicator.Progress
End Sub

' Set or get the progressbar color
Public Sub setProgressBarColor(Color As Paint)
	CSSUtils.SetStyleProperty(ProgressBar_Indicator, "-fx-accent", CSSUtils.ColorToHex(Color))
	mProgressBarColor = Color
End Sub
Public Sub getProgressBarColor As Paint
	Return mProgressBarColor
End Sub
